| LPCOpen Platform v1.03 LPCOpen Platform for NXP LPC Microcontrollers

- Main Page
- Modules
- Data Structures
- Files
- Related Pages

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Data Structures | Macros | Typedefs | Functions
Hardware Abstraction Layer LPC17XX
Hardware Abstraction Layer

## Detailed Description

## Data Structures
struct | DMADescriptor

## Macros
#define | USBRAM_SECTION RAM2
#define | USB_REG(CoreID) LPC_USB
#define | FRAME_INT 0x00000001
#define | EP_FAST_INT 0x00000002
#define | EP_SLOW_INT 0x00000004
#define | DEV_STAT_INT 0x00000008
#define | CCEMTY_INT 0x00000010
#define | CDFULL_INT 0x00000020
#define | RxENDPKT_INT 0x00000040
#define | TxENDPKT_INT 0x00000080
#define | EP_RLZED_INT 0x00000100
#define | ERR_INT 0x00000200
#define | PKT_LNGTH_MASK 0x000003FF
#define | PKT_DV 0x00000400
#define | PKT_RDY 0x00000800
#define | CTRL_RD_EN 0x00000001
#define | CTRL_WR_EN 0x00000002
#define | CMD_SET_ADDR 0x00D00500
#define | CMD_CFG_DEV 0x00D80500
#define | CMD_SET_MODE 0x00F30500
#define | CMD_RD_FRAME 0x00F50500
#define | DAT_RD_FRAME 0x00F50200
#define | CMD_RD_TEST 0x00FD0500
#define | DAT_RD_TEST 0x00FD0200
#define | CMD_SET_DEV_STAT 0x00FE0500
#define | CMD_GET_DEV_STAT 0x00FE0500
#define | DAT_GET_DEV_STAT 0x00FE0200
#define | CMD_GET_ERR_CODE 0x00FF0500
#define | DAT_GET_ERR_CODE 0x00FF0200
#define | CMD_RD_ERR_STAT 0x00FB0500
#define | DAT_RD_ERR_STAT 0x00FB0200
#define | DAT_WR_BYTE(x) (0x00000100 | ((x) << 16))
#define | CMD_SEL_EP(x) (0x00000500 | ((x) << 16))
#define | DAT_SEL_EP(x) (0x00000200 | ((x) << 16))
#define | CMD_SEL_EP_CLRI(x) (0x00400500 | ((x) << 16))
#define | DAT_SEL_EP_CLRI(x) (0x00400200 | ((x) << 16))
#define | CMD_SET_EP_STAT(x) (0x00400500 | ((x) << 16))
#define | CMD_CLR_BUF 0x00F20500
#define | DAT_CLR_BUF 0x00F20200
#define | CMD_VALID_BUF 0x00FA0500
#define | DEV_ADDR_MASK 0x7F
#define | DEV_EN 0x80
#define | CONF_DVICE 0x01
#define | AP_CLK 0x01
#define | INAK_CI 0x02
#define | INAK_CO 0x04
#define | INAK_II 0x08
#define | INAK_IO 0x10
#define | INAK_BI 0x20
#define | INAK_BO 0x40
#define | DEV_CON 0x01
#define | DEV_CON_CH 0x02
#define | DEV_SUS 0x04
#define | DEV_SUS_CH 0x08
#define | DEV_RST 0x10
#define | ERR_EC_MASK 0x0F
#define | ERR_EA 0x10
#define | ERR_PID 0x01
#define | ERR_UEPKT 0x02
#define | ERR_DCRC 0x04
#define | ERR_TIMOUT 0x08
#define | ERR_EOP 0x10
#define | ERR_B_OVRN 0x20
#define | ERR_BTSTF 0x40
#define | ERR_TGL 0x80
#define | EP_SEL_F 0x01
#define | EP_SEL_ST 0x02
#define | EP_SEL_STP 0x04
#define | EP_SEL_PO 0x08
#define | EP_SEL_EPN 0x10
#define | EP_SEL_B_1_FULL 0x20
#define | EP_SEL_B_2_FULL 0x40
#define | EP_STAT_ST 0x01
#define | EP_STAT_DA 0x20
#define | EP_STAT_RF_MO 0x40
#define | EP_STAT_CND_ST 0x80
#define | CLR_BUF_PO 0x01
#define | EOT_INT 0x01
#define | NDD_REQ_INT 0x02
#define | SYS_ERR_INT 0x04

## Typedefs
typedef struct DMADescriptor * | PDMADescriptor

## Functions
void | HcdIrqHandler (uint8_t HostID)
| Interrupt Handler (Host side). This handler is known as interrupt service routine of USB Host.
void | HAL_Reset (uint8_t corenum)
void | HAL_SetDeviceAddress (uint8_t Address)
| Set device address.
void | HAL17XX_USBConnect (uint32_t con)
| Send connect SIE command.
uint32_t | SIE_ReadCommandData (uint32_t cmd)
| Read SIE command data.

## Macro Definition Documentation

#define AP_CLK 0x01

Definition at line 127 of file HAL_LPC17xx.h.

#define CCEMTY_INT 0x00000010

Definition at line 78 of file HAL_LPC17xx.h.

#define CDFULL_INT 0x00000020

Definition at line 79 of file HAL_LPC17xx.h.

#define CLR_BUF_PO 0x01

Definition at line 172 of file HAL_LPC17xx.h.

#define CMD_CFG_DEV 0x00D80500

Definition at line 96 of file HAL_LPC17xx.h.

#define CMD_CLR_BUF 0x00F20500

Definition at line 115 of file HAL_LPC17xx.h.

#define CMD_GET_DEV_STAT 0x00FE0500

Definition at line 103 of file HAL_LPC17xx.h.

#define CMD_GET_ERR_CODE 0x00FF0500

Definition at line 105 of file HAL_LPC17xx.h.

#define CMD_RD_ERR_STAT 0x00FB0500

Definition at line 107 of file HAL_LPC17xx.h.

#define CMD_RD_FRAME 0x00F50500

Definition at line 98 of file HAL_LPC17xx.h.

#define CMD_RD_TEST 0x00FD0500

Definition at line 100 of file HAL_LPC17xx.h.

#define CMD_SEL_EP | ( |  | x | ) | (0x00000500 | ((x) << 16))

Definition at line 110 of file HAL_LPC17xx.h.

#define CMD_SEL_EP_CLRI | ( |  | x | ) | (0x00400500 | ((x) << 16))

Definition at line 112 of file HAL_LPC17xx.h.

#define CMD_SET_ADDR 0x00D00500

Definition at line 95 of file HAL_LPC17xx.h.

#define CMD_SET_DEV_STAT 0x00FE0500

Definition at line 102 of file HAL_LPC17xx.h.

#define CMD_SET_EP_STAT | ( |  | x | ) | (0x00400500 | ((x) << 16))

Definition at line 114 of file HAL_LPC17xx.h.

#define CMD_SET_MODE 0x00F30500

Definition at line 97 of file HAL_LPC17xx.h.

#define CMD_VALID_BUF 0x00FA0500

Definition at line 117 of file HAL_LPC17xx.h.

#define CONF_DVICE 0x01

Definition at line 124 of file HAL_LPC17xx.h.

#define CTRL_RD_EN 0x00000001

Definition at line 91 of file HAL_LPC17xx.h.

#define CTRL_WR_EN 0x00000002

Definition at line 92 of file HAL_LPC17xx.h.

#define DAT_CLR_BUF 0x00F20200

Definition at line 116 of file HAL_LPC17xx.h.

#define DAT_GET_DEV_STAT 0x00FE0200

Definition at line 104 of file HAL_LPC17xx.h.

#define DAT_GET_ERR_CODE 0x00FF0200

Definition at line 106 of file HAL_LPC17xx.h.

#define DAT_RD_ERR_STAT 0x00FB0200

Definition at line 108 of file HAL_LPC17xx.h.

#define DAT_RD_FRAME 0x00F50200

Definition at line 99 of file HAL_LPC17xx.h.

#define DAT_RD_TEST 0x00FD0200

Definition at line 101 of file HAL_LPC17xx.h.

#define DAT_SEL_EP | ( |  | x | ) | (0x00000200 | ((x) << 16))

Definition at line 111 of file HAL_LPC17xx.h.

#define DAT_SEL_EP_CLRI | ( |  | x | ) | (0x00400200 | ((x) << 16))

Definition at line 113 of file HAL_LPC17xx.h.

#define DAT_WR_BYTE | ( |  | x | ) | (0x00000100 | ((x) << 16))

Definition at line 109 of file HAL_LPC17xx.h.

#define DEV_ADDR_MASK 0x7F

Definition at line 120 of file HAL_LPC17xx.h.

#define DEV_CON 0x01

Definition at line 136 of file HAL_LPC17xx.h.

#define DEV_CON_CH 0x02

Definition at line 137 of file HAL_LPC17xx.h.

#define DEV_EN 0x80

Definition at line 121 of file HAL_LPC17xx.h.

#define DEV_RST 0x10

Definition at line 140 of file HAL_LPC17xx.h.

#define DEV_STAT_INT 0x00000008

Definition at line 77 of file HAL_LPC17xx.h.

#define DEV_SUS 0x04

Definition at line 138 of file HAL_LPC17xx.h.

#define DEV_SUS_CH 0x08

Definition at line 139 of file HAL_LPC17xx.h.

#define EOT_INT 0x01

Definition at line 175 of file HAL_LPC17xx.h.

#define EP_FAST_INT 0x00000002

Definition at line 75 of file HAL_LPC17xx.h.

#define EP_RLZED_INT 0x00000100

Definition at line 82 of file HAL_LPC17xx.h.

#define EP_SEL_B_1_FULL 0x20

Definition at line 162 of file HAL_LPC17xx.h.

#define EP_SEL_B_2_FULL 0x40

Definition at line 163 of file HAL_LPC17xx.h.

#define EP_SEL_EPN 0x10

Definition at line 161 of file HAL_LPC17xx.h.

#define EP_SEL_F 0x01

Definition at line 157 of file HAL_LPC17xx.h.

#define EP_SEL_PO 0x08

Definition at line 160 of file HAL_LPC17xx.h.

#define EP_SEL_ST 0x02

Definition at line 158 of file HAL_LPC17xx.h.

#define EP_SEL_STP 0x04

Definition at line 159 of file HAL_LPC17xx.h.

#define EP_SLOW_INT 0x00000004

Definition at line 76 of file HAL_LPC17xx.h.

#define EP_STAT_CND_ST 0x80

Definition at line 169 of file HAL_LPC17xx.h.

#define EP_STAT_DA 0x20

Definition at line 167 of file HAL_LPC17xx.h.

#define EP_STAT_RF_MO 0x40

Definition at line 168 of file HAL_LPC17xx.h.

#define EP_STAT_ST 0x01

Definition at line 166 of file HAL_LPC17xx.h.

#define ERR_B_OVRN 0x20

Definition at line 152 of file HAL_LPC17xx.h.

#define ERR_BTSTF 0x40

Definition at line 153 of file HAL_LPC17xx.h.

#define ERR_DCRC 0x04

Definition at line 149 of file HAL_LPC17xx.h.

#define ERR_EA 0x10

Definition at line 144 of file HAL_LPC17xx.h.

#define ERR_EC_MASK 0x0F

Definition at line 143 of file HAL_LPC17xx.h.

#define ERR_EOP 0x10

Definition at line 151 of file HAL_LPC17xx.h.

#define ERR_INT 0x00000200

Definition at line 83 of file HAL_LPC17xx.h.

#define ERR_PID 0x01

Definition at line 147 of file HAL_LPC17xx.h.

#define ERR_TGL 0x80

Definition at line 154 of file HAL_LPC17xx.h.

#define ERR_TIMOUT 0x08

Definition at line 150 of file HAL_LPC17xx.h.

#define ERR_UEPKT 0x02

Definition at line 148 of file HAL_LPC17xx.h.

#define FRAME_INT 0x00000001

Definition at line 74 of file HAL_LPC17xx.h.

#define INAK_BI 0x20

Definition at line 132 of file HAL_LPC17xx.h.

#define INAK_BO 0x40

Definition at line 133 of file HAL_LPC17xx.h.

#define INAK_CI 0x02

Definition at line 128 of file HAL_LPC17xx.h.

#define INAK_CO 0x04

Definition at line 129 of file HAL_LPC17xx.h.

#define INAK_II 0x08

Definition at line 130 of file HAL_LPC17xx.h.

#define INAK_IO 0x10

Definition at line 131 of file HAL_LPC17xx.h.

#define NDD_REQ_INT 0x02

Definition at line 176 of file HAL_LPC17xx.h.

#define PKT_DV 0x00000400

Definition at line 87 of file HAL_LPC17xx.h.

#define PKT_LNGTH_MASK 0x000003FF

Definition at line 86 of file HAL_LPC17xx.h.

#define PKT_RDY 0x00000800

Definition at line 88 of file HAL_LPC17xx.h.

#define RxENDPKT_INT 0x00000040

Definition at line 80 of file HAL_LPC17xx.h.

#define SYS_ERR_INT 0x04

Definition at line 177 of file HAL_LPC17xx.h.

#define TxENDPKT_INT 0x00000080

Definition at line 81 of file HAL_LPC17xx.h.

#define USB_REG | ( |  | CoreID | ) | LPC_USB

Definition at line 60 of file HAL_LPC17xx.h.

#define USBRAM_SECTION RAM2

Definition at line 44 of file HAL_LPC17xx.h.

## Typedef Documentation

typedef struct DMADescriptor * PDMADescriptor

## Function Documentation

void HAL17XX_USBConnect | ( | uint32_t | con | ) |

Send connect SIE command.

Parameters

  con | : connect or disconnect status

Returns
  Nothing.

void HAL_Reset | ( | uint8_t | corenum | ) |

void HAL_SetDeviceAddress | ( | uint8_t | Address | ) |

Set device address.

Parameters

  Address | : Address to be set

Returns
  Nothing.

void HcdIrqHandler | ( | uint8_t | HostID | ) |

Interrupt Handler (Host side). This handler is known as interrupt service routine of USB Host.

Parameters

  HostID | : Host ID

Returns
  Nothing.

uint32_t SIE_ReadCommandData | ( | uint32_t | cmd | ) |

Read SIE command data.

Parameters

  cmd | : command code

Returns
  Data.